<!doctype html>
<html lang="en">

<head>
    <title>Title</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- DataTable -->
    <!--  -->
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.15.4/css/all.css"
        integrity="sha384-DyZ88mC6Up2uqS4h/KRgHuoeGwBcD4Ng9SiP4dIRy0EXTlnuz47vAwmeGwVChigm" crossorigin="anonymous" />
</head>

<body>
    <div class="container">
        <div class="jumbotron">

            <div class="row">
                <div class="col-sm-4">
                    <label for="">Mã Nước Uống</label>
                </div>
                <div class="col-sm-8">
                    <input type="text" id="inp-ma-nuoc-uong" class="form-control">
                </div>
            </div>
            <div class="row mt-3">
                <div class="col-sm-4">
                    <label for="">Tên Nước Uống</label>
                </div>
                <div class="col-sm-8">
                    <input type="text" id="inp-ten-nuoc-uong" class="form-control">
                </div>
            </div>
            <div class="row mt-3">
                <div class="col-sm-4">
                    <label for="">Ngày Tạo</label>
                </div>
                <div class="col-sm-8">
                    <input id="inp-ngay-tao" type="date" value="" class="form-control" />
                </div>
            </div>
            <div class="row mt-3">
                <div class="col-sm-4">
                    <label for="">Ngày Cập Nhật</label>
                </div>
                <div class="col-sm-8">
                    <input id="inp-ngay-cap-nhat" type="date" value="" class="form-control" />
                </div>
            </div>

            <div class="row mt-5">
                <button id="btn-add" class="btn btn-info mr-5">Add Drink</button>

                <button id="btn-delete-all" class="btn btn-warning mr-5">Delete all Drink</button>
                <button id="btn-update-save" class="btn btn-success mr-5" disabled>Update Drink</button>

            </div>


        </div>

        <table class="table table-bordered table-striped" id="table-drink">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Mã Nước Uống</th>
                    <th>Tên Nước Uống</th>
                    <th>Ngày Tạo</th>
                    <th>Ngày Cập Nhật</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>


    </div>


</body>
<script>
    // **   region1   **///
    const gBASE_URL_DRINK = "http://localhost:8080/drinks";
    var gSTT = 0;
    var gDataRow = "";
    // **   region2   **///
    $(document).ready(function () {
        onTableDrink();
        onLoadDataTable();
        $("#btn-add").on("click", function () {
            addDrink();
        })

        $("#table-drink").on("click", ".btn-update", function () {
            gDataRow = getDataRowTable(this);
            $("#btn-update-save").prop('disabled', false);
            $("#btn-add").prop('disabled', true);
            $("#btn-delete-all").prop('disabled', true);

            hienThiThongTinUpdate();
            $("#btn-update-save").on("click", function () {
                updateDrink();
            })

        })
        $("#table-drink").on("click", ".btn-delete", function () {
            gDataRow = getDataRowTable(this);
            deleteDrink();
        })
        $("#btn-delete-all").on("click", function () {
            deleteAllDrink();
        })

    })
    // **   region3   **///
    function onTableDrink() {
        $("#table-drink").DataTable({
            columns: [
                { "data": "stt" },
                { "data": "maNuocUong" },
                { "data": "tenNuocUong" },
                { "data": "ngayTao" },
                { "data": "ngayCapNhat" },
                { "data": "action" },


            ],
            columnDefs: [
                {
                    targets: 0,
                    render: function renderSTT() {
                        gSTT++;
                        return gSTT;
                    }
                },

                {
                    targets: 5,
                    defaultContent: '<i class="fas fa-edit fa-lg mr-3 btn-update"></i>' + '<i class="fas fa-trash-alt fa-lg btn-delete"></i>'

                }
            ]

        })
    }
    function drawTable(paramData) {
        var vTable = $("#table-drink").DataTable();
        vTable.clear();
        gSTT = 0;
        vTable.rows.add(paramData);
        vTable.draw();

    }
    function onLoadDataTable() {
        $.ajax({
            url: gBASE_URL_DRINK,
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                drawTable(paramRes);
            },
            error: function (paramErr) {
                alert(status.paramErr);
            }
        })
    }
    function addDrink() {
        var vObjDrink = {
            maNuocUong: "",
            tenNuocUong: "",
        }
        thuThapThongTin(vObjDrink);
        var vcheck = validateDataDrink(vObjDrink);
        if (vcheck) {
            $.ajax({
                url: gBASE_URL_DRINK,
                type: "POST",
                data: JSON.stringify(vObjDrink),
                contentType: "application/json;charset=UTF-8",
                success: function (paramRes) {
                    handleCreate();
                },
                error: function (paramErr) {
                    alert(statusbar.paramErr);
                }
            })
        }

    }
    function updateDrink() {
        var vObjDrink = {
            maNuocUong: "",
            tenNuocUong: "",
            ngayCapNhat: "",
        }
        thuThapThongTin(vObjDrink);


        $.ajax({
            url: gBASE_URL_DRINK + "/" + gDataRow.id,
            type: "PUT",
            data: JSON.stringify(vObjDrink),
            contentType: "application/json;charset=UTF-8",
            success: function (paramRes) {
                handleUpdate();
            },
            error: function (paramErr) {
                alert(statusbar.paramErr);
            }
        })


    }
    function deleteDrink() {
        $.ajax({
            url: gBASE_URL_DRINK + "/" + gDataRow.id,
            type: "DELETE",

            success: function (paramRes) {
                alert("delete success");
                location.reload();
            },
            error: function (paramErr) {
                alert(statusbar.paramErr);
            }
        })
    }
    function deleteAllDrink() {
        $.ajax({
            url: gBASE_URL_DRINK,
            type: "DELETE",

            success: function (paramRes) {
                alert("delete all success");
                location.reload();
            },
            error: function (paramErr) {
                alert(statusbar.paramErr);
            }
        })
    }
    // **   region4   **///
    function thuThapThongTin(paramObj) {
        paramObj.maNuocUong = $("#inp-ma-nuoc-uong").val();
        paramObj.tenNuocUong = $("#inp-ten-nuoc-uong").val();
        paramObj.ngayCapNhat = $("#inp-ngay-cap-nhat").val();

    }
    function validateDataDrink(paramObj) {
        if (paramObj.maNuocUong == "" || paramObj.tenNuocUong == "") {
            alert("Nhập mã nước uống và tên nước uống");
            return false;
        }
        return true;

    }
    function handleCreate() {
        $("inp-ma-nuoc-uong").html("");
        $("inp-ten-nuoc-uong").html("");
        location.reload();
    }
    function handleUpdate() {
        alert("Update success")
        $("inp-ma-nuoc-uong").html("");
        $("inp-ten-nuoc-uong").html("");
        location.reload();
    }
    function getDataRowTable(paramElement) {

        var vTable = $("#table-drink").DataTable();
        var vRow = $(paramElement).closest("tr");
        var vData = vTable.row(vRow).data();
        return vData;
    }
    function hienThiThongTinUpdate() {
        $("#inp-ten-nuoc-uong").val(gDataRow.tenNuocUong);
        $("#inp-ma-nuoc-uong").val(gDataRow.maNuocUong);
        $("#inp-ngay-cap-nhat").val(gDataRow.ngayCapNhat);
        $("#inp-ngay-tao").val(gDataRow.ngayTao);
    }


</script>

</html>